Tests for the Lock-free Contention Adapting Search Trees
========================================================

This folder contains C code that has been used to generate the
pseudocode of the following publication:

Kjell Winblad, Konstantinos Sagonas and Bengt Jonsson. Lock-free
Contention Adapting Search Trees. In Proceedings of the 30th ACM
Symposium on Parallelism in Algorithms and Architectures, SPAA'2018

The above publication describes a concurrent data structure for ordered
sets and key-value stores with support for range queries called the
Lock-free Contention Adapting Search Tree (LFCA tree).

The preprint version of this paper can be found here:

http://www.it.uu.se/research/group/languages/software/ca_tree

Tests For the Code
------------------

There are two types of tests for the code. The first kind applies
stress tests by letting multiple concurrent threads execute operations
on the data structure. The second type of tests use the
[Nidhugg](https://github.com/nidhugg/nidhugg) testing tool to
systematically explore all interesting interleavings of some test
cases.

Both types of tests are based on a testing technique that compare the
LFCA tree implementation against a model. That is, all linearization
points happen in a critical section of a global lock in which the
operation's result is compared against the corresponding result of the
model data structure.

Running the Stress Tests
------------------------

```
make run_parallel_tests_range_query
make run_parallel_tests_single_key
```


Running the Nidhugg Tests
------------------------

```
make nidhugg_run_genereted_simple_par_ops_test.c
```

Requires [docker](https://www.docker.com/)


License
-------

GNU General Public License (GPL) Version 3
