#include <stdbool.h>


typedef struct model_impl model;


model * model_create();

/*
 * input:
 * m = input treap instance (will not be modified)
 * i = item to insert (must be positive)
 *
 * output:
 * false if an item with value i already existed and false otherwise
 */
bool model_insert(model * m, int i);

/*
 * input:
 * m = input treap instance (will not be modified)
 * i = item to insert (must be positive)
 *
 * output:
 * false if an item with value i already existed and false otherwise
 */
bool model_remove(model * m, int i);


/*
 * input:
 * m = input treap instance
 * i = item to lookup
 *
 * output:
 * true if the value i exist in i and false otherwise
 */
bool model_lookup(model * m, int i);

/*
 * input:
 * m = input treap instance
 * traverser = a function that will be called once for all items in the range in icreasing order
 *                v = the current item in the range
 *                inaux = will be set to the value passed as the parameter aux
 * aux = some auxallary data (can be used to store items in range)
 *
 * output:
 * true if the value i exist in i and false otherwise
 */
void model_range_query(model * m, int start, int end, void (*traverser)(int v, void* inaux), void* aux);
