#include <stdio.h>
#include <assert.h>

#ifndef __TEST_FRAMEWORK_H__
#define __TEST_FRAMEWORK_H__


#define TO_VP(intValue) (void *)(intValue)

#ifdef SILENT_TEST
#define MY_PRINTF(ARGS) 
#else
#define MY_PRINTF(ARGS) printf ARGS ; 
#endif

#define T(testFunCall, tesName)                 \
    MY_PRINTF(("STARTING TEST: "));             \
    test(testFunCall, tesName);

#define ASSERT(assertion, text)                         \
    if(!(assertion)){                                   \
        MY_PRINTF(("ASSERTION FAILED: %s\n", text));    \
        return 0;                                       \
    }

void test(int success, char msg[]){

    if(success){
        MY_PRINTF(("\033[32m -- SUCCESS! -- \033[m"));
    }else{
        MY_PRINTF(("\033[31m -- FAIL! -- \033[m"));
    }

    MY_PRINTF(("TEST: %s\n", msg));

}

#endif
